Skip to content

Commit 2f5401d

Browse files
committed
Added python
1 parent 3e7f340 commit 2f5401d

File tree

115 files changed

+8082
-497
lines changed

Some content is hidden

Large Commits have some content hidden by default. Use the searchbox below for content that may be hidden.

115 files changed

+8082
-497
lines changed

README.md

+380-380
Large diffs are not rendered by default.
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,57 @@
1+
[![](https://img.shields.io/github/stars/javadev/LeetCode-in-All?label=Stars&style=flat-square)](https://github.com/javadev/LeetCode-in-All)
2+
[![](https://img.shields.io/github/forks/javadev/LeetCode-in-All?label=Fork%20me%20on%20GitHub%20&style=flat-square)](https://github.com/javadev/LeetCode-in-All/fork)
3+
4+
## 1\. Two Sum
5+
6+
Easy
7+
8+
Given an array of integers `nums` and an integer `target`, return _indices of the two numbers such that they add up to `target`_.
9+
10+
You may assume that each input would have **_exactly_ one solution**, and you may not use the _same_ element twice.
11+
12+
You can return the answer in any order.
13+
14+
**Example 1:**
15+
16+
**Input:** nums = [2,7,11,15], target = 9
17+
18+
**Output:** [0,1]
19+
20+
**Explanation:** Because nums[0] + nums[1] == 9, we return [0, 1].
21+
22+
**Example 2:**
23+
24+
**Input:** nums = [3,2,4], target = 6
25+
26+
**Output:** [1,2]
27+
28+
**Example 3:**
29+
30+
**Input:** nums = [3,3], target = 6
31+
32+
**Output:** [0,1]
33+
34+
**Constraints:**
35+
36+
* <code>2 <= nums.length <= 10<sup>4</sup></code>
37+
* <code>-10<sup>9</sup> <= nums[i] <= 10<sup>9</sup></code>
38+
* <code>-10<sup>9</sup> <= target <= 10<sup>9</sup></code>
39+
* **Only one valid answer exists.**
40+
41+
**Follow-up:** Can you come up with an algorithm that is less than <code>O(n<sup>2</sup>)</code> time complexity?
42+
43+
44+
45+
## Solution
46+
47+
```python
48+
class Solution:
49+
def twoSum(self, numbers: List[int], target: int) -> List[int]:
50+
index_map = {}
51+
for i, num in enumerate(numbers):
52+
required_num = target - num
53+
if required_num in index_map:
54+
return [index_map[required_num], i]
55+
index_map[num] = i
56+
return [-1, -1]
57+
```
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,72 @@
1+
[![](https://img.shields.io/github/stars/javadev/LeetCode-in-All?label=Stars&style=flat-square)](https://github.com/javadev/LeetCode-in-All)
2+
[![](https://img.shields.io/github/forks/javadev/LeetCode-in-All?label=Fork%20me%20on%20GitHub%20&style=flat-square)](https://github.com/javadev/LeetCode-in-All/fork)
3+
4+
## 2\. Add Two Numbers
5+
6+
Medium
7+
8+
You are given two **non-empty** linked lists representing two non-negative integers. The digits are stored in **reverse order**, and each of their nodes contains a single digit. Add the two numbers and return the sum as a linked list.
9+
10+
You may assume the two numbers do not contain any leading zero, except the number 0 itself.
11+
12+
**Example 1:**
13+
14+
![](https://assets.leetcode.com/uploads/2020/10/02/addtwonumber1.jpg)
15+
16+
**Input:** l1 = [2,4,3], l2 = [5,6,4]
17+
18+
**Output:** [7,0,8]
19+
20+
**Explanation:** 342 + 465 = 807.
21+
22+
**Example 2:**
23+
24+
**Input:** l1 = [0], l2 = [0]
25+
26+
**Output:** [0]
27+
28+
**Example 3:**
29+
30+
**Input:** l1 = [9,9,9,9,9,9,9], l2 = [9,9,9,9]
31+
32+
**Output:** [8,9,9,9,0,0,0,1]
33+
34+
**Constraints:**
35+
36+
* The number of nodes in each linked list is in the range `[1, 100]`.
37+
* `0 <= Node.val <= 9`
38+
* It is guaranteed that the list represents a number that does not have leading zeros.
39+
40+
41+
42+
## Solution
43+
44+
```python
45+
# Definition for singly-linked list.
46+
# class ListNode:
47+
# def __init__(self, val=0, next=None):
48+
# self.val = val
49+
# self.next = next
50+
class Solution:
51+
def addTwoNumbers(self, l1: Optional[ListNode], l2: Optional[ListNode]) -> Optional[ListNode]:
52+
dummy_head = ListNode(0)
53+
p, q, curr = l1, l2, dummy_head
54+
carry = 0
55+
56+
while p is not None or q is not None:
57+
x = p.val if p is not None else 0
58+
y = q.val if q is not None else 0
59+
sum = carry + x + y
60+
carry = sum // 10
61+
curr.next = ListNode(sum % 10)
62+
curr = curr.next
63+
if p is not None:
64+
p = p.next
65+
if q is not None:
66+
q = q.next
67+
68+
if carry > 0:
69+
curr.next = ListNode(carry)
70+
71+
return dummy_head.next
72+
```
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,71 @@
1+
[![](https://img.shields.io/github/stars/javadev/LeetCode-in-All?label=Stars&style=flat-square)](https://github.com/javadev/LeetCode-in-All)
2+
[![](https://img.shields.io/github/forks/javadev/LeetCode-in-All?label=Fork%20me%20on%20GitHub%20&style=flat-square)](https://github.com/javadev/LeetCode-in-All/fork)
3+
4+
## 3\. Longest Substring Without Repeating Characters
5+
6+
Medium
7+
8+
Given a string `s`, find the length of the **longest substring** without repeating characters.
9+
10+
**Example 1:**
11+
12+
**Input:** s = "abcabcbb"
13+
14+
**Output:** 3
15+
16+
**Explanation:** The answer is "abc", with the length of 3.
17+
18+
**Example 2:**
19+
20+
**Input:** s = "bbbbb"
21+
22+
**Output:** 1
23+
24+
**Explanation:** The answer is "b", with the length of 1.
25+
26+
**Example 3:**
27+
28+
**Input:** s = "pwwkew"
29+
30+
**Output:** 3
31+
32+
**Explanation:** The answer is "wke", with the length of 3. Notice that the answer must be a substring, "pwke" is a subsequence and not a substring.
33+
34+
**Example 4:**
35+
36+
**Input:** s = ""
37+
38+
**Output:** 0
39+
40+
**Constraints:**
41+
42+
* <code>0 <= s.length <= 5 * 10<sup>4</sup></code>
43+
* `s` consists of English letters, digits, symbols and spaces.
44+
45+
46+
47+
## Solution
48+
49+
```python
50+
class Solution:
51+
def lengthOfLongestSubstring(self, s: str) -> int:
52+
last_indices = [-1] * 256
53+
max_len = 0
54+
cur_len = 0
55+
start = 0
56+
57+
for i, char in enumerate(s):
58+
if last_indices[ord(char)] < start:
59+
last_indices[ord(char)] = i
60+
cur_len += 1
61+
else:
62+
last_index = last_indices[ord(char)]
63+
start = last_index + 1
64+
cur_len = i - start + 1
65+
last_indices[ord(char)] = i
66+
67+
if cur_len > max_len:
68+
max_len = cur_len
69+
70+
return max_len
71+
```
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,87 @@
1+
[![](https://img.shields.io/github/stars/javadev/LeetCode-in-All?label=Stars&style=flat-square)](https://github.com/javadev/LeetCode-in-All)
2+
[![](https://img.shields.io/github/forks/javadev/LeetCode-in-All?label=Fork%20me%20on%20GitHub%20&style=flat-square)](https://github.com/javadev/LeetCode-in-All/fork)
3+
4+
## 4\. Median of Two Sorted Arrays
5+
6+
Hard
7+
8+
Given two sorted arrays `nums1` and `nums2` of size `m` and `n` respectively, return **the median** of the two sorted arrays.
9+
10+
The overall run time complexity should be `O(log (m+n))`.
11+
12+
**Example 1:**
13+
14+
**Input:** nums1 = [1,3], nums2 = [2]
15+
16+
**Output:** 2.00000
17+
18+
**Explanation:** merged array = [1,2,3] and median is 2.
19+
20+
**Example 2:**
21+
22+
**Input:** nums1 = [1,2], nums2 = [3,4]
23+
24+
**Output:** 2.50000
25+
26+
**Explanation:** merged array = [1,2,3,4] and median is (2 + 3) / 2 = 2.5.
27+
28+
**Example 3:**
29+
30+
**Input:** nums1 = [0,0], nums2 = [0,0]
31+
32+
**Output:** 0.00000
33+
34+
**Example 4:**
35+
36+
**Input:** nums1 = [], nums2 = [1]
37+
38+
**Output:** 1.00000
39+
40+
**Example 5:**
41+
42+
**Input:** nums1 = [2], nums2 = []
43+
44+
**Output:** 2.00000
45+
46+
**Constraints:**
47+
48+
* `nums1.length == m`
49+
* `nums2.length == n`
50+
* `0 <= m <= 1000`
51+
* `0 <= n <= 1000`
52+
* `1 <= m + n <= 2000`
53+
* <code>-10<sup>6</sup> <= nums1[i], nums2[i] <= 10<sup>6</sup></code>
54+
55+
56+
57+
## Solution
58+
59+
```python
60+
class Solution:
61+
def findMedianSortedArrays(self, nums1: List[int], nums2: List[int]) -> float:
62+
if len(nums2) < len(nums1):
63+
return self.findMedianSortedArrays(nums2, nums1)
64+
65+
n1, n2 = len(nums1), len(nums2)
66+
low, high = 0, n1
67+
68+
while low <= high:
69+
cut1 = (low + high) // 2
70+
cut2 = (n1 + n2 + 1) // 2 - cut1
71+
72+
l1 = float('-inf') if cut1 == 0 else nums1[cut1 - 1]
73+
l2 = float('-inf') if cut2 == 0 else nums2[cut2 - 1]
74+
r1 = float('inf') if cut1 == n1 else nums1[cut1]
75+
r2 = float('inf') if cut2 == n2 else nums2[cut2]
76+
77+
if l1 <= r2 and l2 <= r1:
78+
if (n1 + n2) % 2 == 0:
79+
return (max(l1, l2) + min(r1, r2)) / 2.0
80+
return max(l1, l2)
81+
elif l1 > r2:
82+
high = cut1 - 1
83+
else:
84+
low = cut1 + 1
85+
86+
return 0.0
87+
```
Original file line numberDiff line numberDiff line change
@@ -0,0 +1,77 @@
1+
[![](https://img.shields.io/github/stars/javadev/LeetCode-in-All?label=Stars&style=flat-square)](https://github.com/javadev/LeetCode-in-All)
2+
[![](https://img.shields.io/github/forks/javadev/LeetCode-in-All?label=Fork%20me%20on%20GitHub%20&style=flat-square)](https://github.com/javadev/LeetCode-in-All/fork)
3+
4+
## 5\. Longest Palindromic Substring
5+
6+
Medium
7+
8+
Given a string `s`, return _the longest palindromic substring_ in `s`.
9+
10+
**Example 1:**
11+
12+
**Input:** s = "babad"
13+
14+
**Output:** "bab" **Note:** "aba" is also a valid answer.
15+
16+
**Example 2:**
17+
18+
**Input:** s = "cbbd"
19+
20+
**Output:** "bb"
21+
22+
**Example 3:**
23+
24+
**Input:** s = "a"
25+
26+
**Output:** "a"
27+
28+
**Example 4:**
29+
30+
**Input:** s = "ac"
31+
32+
**Output:** "a"
33+
34+
**Constraints:**
35+
36+
* `1 <= s.length <= 1000`
37+
* `s` consist of only digits and English letters.
38+
39+
40+
41+
## Solution
42+
43+
```python
44+
class Solution:
45+
def longestPalindrome(self, s: str) -> str:
46+
# Create a new string with separators
47+
new_str = ['#'] * (2 * len(s) + 1)
48+
for i in range(len(s)):
49+
new_str[2 * i + 1] = s[i]
50+
51+
dp = [0] * len(new_str)
52+
friend_center = 0
53+
friend_radius = 0
54+
lps_center = 0
55+
lps_radius = 0
56+
57+
for i in range(len(new_str)):
58+
if friend_center + friend_radius > i:
59+
dp[i] = min(dp[2 * friend_center - i], (friend_center + friend_radius) - i)
60+
else:
61+
dp[i] = 1
62+
63+
while i + dp[i] < len(new_str) and i - dp[i] >= 0 and new_str[i + dp[i]] == new_str[i - dp[i]]:
64+
dp[i] += 1
65+
66+
if friend_center + friend_radius < i + dp[i]:
67+
friend_center = i
68+
friend_radius = dp[i]
69+
70+
if lps_radius < dp[i]:
71+
lps_center = i
72+
lps_radius = dp[i]
73+
74+
start = (lps_center - lps_radius + 1) // 2
75+
end = (lps_center + lps_radius - 1) // 2
76+
return s[start:end]
77+
```

0 commit comments

Comments
 (0)